"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.upperCase = upperCase;
exports.lowerCase = lowerCase;
exports._replace = _replace;
var values_1 = require("../values");
var internal_functions_1 = require("./internal-functions");
function upperCase(context) {
    (0, internal_functions_1.assert)(['2.0', '3.0'].includes(context.xsltVersion));
    var str = this.args[0].evaluate(context).stringValue();
    return new values_1.StringValue(str.toUpperCase());
}
function lowerCase(context) {
    (0, internal_functions_1.assert)(['2.0', '3.0'].includes(context.xsltVersion));
    var str = this.args[0].evaluate(context).stringValue();
    return new values_1.StringValue(str.toLowerCase());
}
function _replace(context) {
    (0, internal_functions_1.assert)(['2.0', '3.0'].includes(context.xsltVersion));
    var str = this.args[0].evaluate(context).stringValue();
    var s1 = this.args[1].evaluate(context).stringValue();
    var s2 = this.args[2].evaluate(context).stringValue();
    var searchPattern = new RegExp(s1, 'g');
    return new values_1.StringValue(str.replace(searchPattern, s2));
}
//# sourceMappingURL=standard-20.js.map