"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NodeSetValue = void 0;
var dom_1 = require("../../dom");
var NodeSetValue = /** @class */ (function () {
    function NodeSetValue(value) {
        this.value = value;
        this.type = 'node-set';
    }
    NodeSetValue.prototype.stringValue = function () {
        if (this.value.length === 0) {
            return '';
        }
        return (0, dom_1.xmlValue)(this.value[0]);
    };
    NodeSetValue.prototype.booleanValue = function () {
        return this.value.length > 0;
    };
    NodeSetValue.prototype.numberValue = function () {
        return parseInt(this.stringValue()) - 0;
    };
    NodeSetValue.prototype.nodeSetValue = function () {
        return this.value;
    };
    return NodeSetValue;
}());
exports.NodeSetValue = NodeSetValue;
//# sourceMappingURL=node-set-value.js.map